import java.net.*;
import java.io.*;

public class Sender extends Thread{
  private boolean serverAttivo;
  private String dirName;
  private int port;
  private InetAddress clientAddress;
  private int clientPort;
  
  
  public Sender(String dirName, int port){
    this. dirName = dirName;
    this.port = port;
    clientAddress = null;
    clientPort = -1;
    serverAttivo=false;
  } //costruttore-client attivo
  
  public Sender(String dirName, int port, InetAddress clientAddress, int clientPort){
    this.dirName = dirName;
    this.port = port;
    this.clientAddress = clientAddress;
    this.clientPort = clientPort;
    serverAttivo=true;
  } //costruttore-server attivo
  
  public void run(){
    Socket sock = null;
    DataOutputStream out = null;
    
    if(serverAttivo){
      //apro la connessione facendo la connect
      try {
        //Thread.sleep(2);
        sock = new Socket(clientAddress,clientPort);
        out = new DataOutputStream(sock.getOutputStream());
      } catch (IOException ioex) {
        System.out.println("Errore nella creazione socket (server attivo), termino");
        ioex.printStackTrace();
        System.exit(4);
      } //try-catch
      
    }else{
      //apro la connessione facendo la accept
      ServerSocket servSock = null;
      try {
        servSock = new ServerSocket(port);
        servSock.setReuseAddress(true);
        sock = servSock.accept();
        out = new DataOutputStream(sock.getOutputStream());
      } catch (IOException ioex) {
        System.out.println("Errore nella creazione socket (client attivo), termino");
        ioex.printStackTrace();
        System.exit(5);
      } //try-catch
    }
    
    //a connessione creata invio i file sulla socket
    File d = new File(dirName);
    if(!d.isDirectory()){
      System.out.println("Errore nell'apertura directory");
      System.exit(5);
    }
    try{
      for (int i = 0; i < d.listFiles().length; i++){
        File temp = d.listFiles()[i];
        DataInputStream fIn = new DataInputStream(new FileInputStream(temp));
        for (int c = 0; c < temp.length(); c++) out.write(fIn.read());
      } //for
      out.flush();
    }catch(IOException e){
      System.out.println("Errore nel trasferimento file");
      e.printStackTrace();
      System.exit(6);
    }
  } //run
} //class
